package uk.co.agileworks.tickets;

import java.io.IOException;

import javax.annotation.Resource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Component;

@Component
public class Main {

	private static final Logger LOGGER = LoggerFactory.getLogger(Main.class);

	public static void main(String[] args) {
		ApplicationContext ctx = new ClassPathXmlApplicationContext("testsite-tickets.xml");
		Main app = ctx.getBean(Main.class);
		LOGGER.info("Checking for tickets...");
		app.run();
	}

	@Autowired
	private EventSearcher eventSearcher;
	
	@Resource
	private String soundFile;

	public final void run() {
		for (String event : eventSearcher.getEvents()) {
			if (eventSearcher.hasTickets(event)) {
				LOGGER.info(event + " -> TICKETS AVAILABLE!");
				playSound();
			} else {
				LOGGER.info(event + " -> no tickets avalaible.");
			}
		}
	}
	
	private void playSound() {
		ProcessBuilder pb = new ProcessBuilder("aplay", soundFile);
		try {
			pb.start();
		} catch (IOException ignore) {
		}
	}

}
