package uk.co.agileworks.testsite.domain;

import java.util.List;

import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

import org.apache.commons.lang3.builder.ToStringBuilder;

@Entity
public final class Question {

	@GeneratedValue
	@Id
	private Long pk;
	private String text;
	@ElementCollection(fetch=FetchType.EAGER)
	@CollectionTable(name = "QUESTION_STEP")
	@Column(name = "STEP")
	private List<String> steps;
	private String answer;

	public String getAnswer() {
		return answer;
	}

	public Long getPk() {
		return pk;
	}

	public List<String> getSteps() {
		return steps;
	}

	public String getText() {
		return text;
	}

	public void setAnswer(String answer) {
		this.answer = answer;
	}

	public void setPk(Long pk) {
		this.pk = pk;
	}

	public void setSteps(List<String> steps) {
		this.steps = steps;
	}

	public void setText(String text) {
		this.text = text;
	}
	
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}

}
