package uk.co.agileworks.testsite.tools;

import org.hibernate.cfg.Configuration;
import org.hibernate.tool.hbm2ddl.SchemaExport;

import uk.co.agileworks.testsite.domain.Question;

public final class SchemaExporter {
	
	private static final String H2_DIALECT = "org.hibernate.dialect.H2Dialect";
	private static final String ORACLE_DIALECT = "org.hibernate.dialect.Oracle10gDialect";
	
	private Configuration configuration = new Configuration();
	
	public SchemaExporter(String hibernateDialect) {
		configuration.setProperty("hibernate.dialect", hibernateDialect);
		configuration.addAnnotatedClass(Question.class);
	}
	
	public void export(String outputFile) {
		SchemaExport export = new SchemaExport(configuration);
		export.setOutputFile(outputFile);
		export.setDelimiter(";");
		export.execute(false, false, false, true);
	}
	
	public static void main(String[] args) {
		new SchemaExporter(H2_DIALECT).export("target/testsite-h2.ddl");
		new SchemaExporter(ORACLE_DIALECT).export("target/testsite-oracle.ddl");
	}
}
