package uk.co.agileworks.testsite.ws;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import org.apache.ws.security.WSPasswordCallback;
import org.springframework.stereotype.Component;

@Component("serverPasswordCallback")
public final class ServerPasswordCallback implements CallbackHandler {

	private static final String WS_USER = "testsite";
	private static final String WS_PASSWORD = "password";

	@Override
	public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException {

		for (Callback callback : callbacks) {
			if (callback instanceof WSPasswordCallback) {
				WSPasswordCallback passwordCallback = (WSPasswordCallback) callback;
				if (passwordCallback.getIdentifier().equals(WS_USER)) {
					passwordCallback.setPassword(WS_PASSWORD);
				}
			}
		}
	}

}
