package uk.co.agileworks.testsite.service;

import static junit.framework.Assert.assertNotSame;
import static junit.framework.Assert.assertSame;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.CacheManager;

import uk.co.agileworks.testsite.domain.Question;
import uk.co.agileworks.testsite.test.DbUnitTest;

public final class CacheTest extends DbUnitTest {
	
	@Autowired
	private QuestionService service;
	
	@Autowired
	private CacheManager cacheManager;
	
	@Test
	public void cached() {
		Question question1 = service.getQuestion(1L);
		Question question2 = service.getQuestion(1L);
		assertSame(question1, question2);
	}
	
	@Test
	public void notCached() {
		Question question1 = service.getQuestion(1L);
		clearCache();
		Question question2 = service.getQuestion(1L);
		assertNotSame(question1, question2);
	}
	
	
	private void clearCache() {
		cacheManager.getCache("questions").clear();
	}

}
