package uk.co.agileworks.testsite.service;

import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import uk.co.agileworks.testsite.dao.QuestionDAO;
import uk.co.agileworks.testsite.domain.Question;
import uk.co.agileworks.testsite.test.DbUnitTest;

public final class QuestionServiceTest extends DbUnitTest {

	private static final Long MOCK_PK = 1L;

	private QuestionService servicePojo = new QuestionServiceImpl();
	private QuestionDAO mockDao = Mockito.mock(QuestionDAO.class);
	private Question testQuestion = getTestData().getQuestion();

	@Test
	public void getQuestion() {
		when(mockDao.getQuestion(MOCK_PK)).thenReturn(testQuestion);
		Question question = servicePojo.getQuestion(MOCK_PK);
		verify(mockDao).getQuestion(MOCK_PK);
		assertEquals(testQuestion, question);
	}

	@Before
	public void runBefore() {
		setField(servicePojo, "questionDAO", mockDao);
	}

}
