package uk.co.agileworks.testsite.test;

import java.lang.reflect.Field;

import org.junit.Ignore;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.AbstractTransactionalJUnit4SpringContextTests;
import org.springframework.util.ReflectionUtils;

import uk.co.agileworks.testsite.domain.Question;

@Ignore
@ContextConfiguration(locations = "file:src/main/webapp/WEB-INF/spring-servlet.xml")
public class SpringTest extends AbstractTransactionalJUnit4SpringContextTests {

	protected static final Logger LOGGER = LoggerFactory.getLogger(SpringTest.class);

	private DataSet testData = new DataSet();
	
	public final DataSet getTestData() {
		return testData;
	}

	public static void assertEquals(Object expected, Object actual) {
		LOGGER.trace("expected [" + expected + "]");
		LOGGER.trace("actual   [" + actual + "]");
		org.junit.Assert.assertEquals(expected, actual);
	}

	public static void assertEquals(Question thisQuestion, Question thatQuestion) {
		assertEquals(thisQuestion.getPk(), thatQuestion.getPk());
		assertEquals(thisQuestion.getText(), thatQuestion.getText());
		assertEquals(thisQuestion.getAnswer(), thatQuestion.getAnswer());
		assertEquals(thisQuestion.getSteps().size(), thatQuestion.getSteps().size());
		for (int i = 0; i < thisQuestion.getSteps().size(); i++) {
			assertEquals(thisQuestion.getSteps().get(i), thatQuestion.getSteps().get(i));
		}
	}

	public static void setField(Object target, String fieldName, Object source) {
		Field field = ReflectionUtils.findField(target.getClass(), fieldName);
		field.setAccessible(true);
		ReflectionUtils.setField(field, target, source);
	}
	
}
